/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.payment.action;

import java.util.List;
import jp.mosp.common.common.BaseDto;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.dao.CmBankDao;
import jp.mosp.payroll.dao.CmBranchDao;
import jp.mosp.payroll.dto.CmBankDto;
import jp.mosp.payroll.dto.CmBranchDto;
import jp.mosp.payroll.payment.vo.CompanyBankBranchEditVo;

/**
 * 銀行・支店マスタのメンテナンスに必要な機能を提供する。<br>
 * 銀行・支店マスタの一覧表示、及び登録・更新が可能。<br>
 */
public class CompanyBankBranchEditAction extends PayrollAction {

	// コマンド
	private static final String CMD_CM_BANK_BRANCH_SHOW      = "U5280";
	private static final String CMD_CM_BANK_INSERT           = "U5281";
	private static final String CMD_CM_BANK_UPDATE           = "U5282";
	private static final String CMD_CM_BRANCH_INSERT         = "U5283";
	private static final String CMD_CM_BRANCH_UPDATE         = "U5284";
	private static final String CMD_CM_BANK_BRANCH_SELECT    = "U5285";
	private static final String CMD_CM_BANK_BRANCH_RE_SEARCH = "U5286";
	private static final String CMD_CM_BANK_SEARCH           = "U5288";
	
	/**
	 * Actionの初期化を行う。<br><br>
	 * 以下の処理を行う。
	 * <ul><li>
	 * {@link PayrollAction#PayrollAction()}
	 * </li></ul>
	 */
	public CompanyBankBranchEditAction() {
		super();
	}

	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new CompanyBankBranchEditVo();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// PAYROLL権限確認
		confirmPayrollAuth();
		// VO取得及び設定
		prepareVo();
		CompanyBankBranchEditVo vo = (CompanyBankBranchEditVo)getVo();
		// DAO
		CmBankDao   cmBankdao;
		CmBranchDao cmBranchdao;
		// DTO
		CmBankDto   cmBankdto   = null;
		CmBranchDto cmBranchdto = null;
		
		BaseDto[] aryDto = (BaseDto[])session.getAttribute(MospConst.ATT_DTO);
		if (aryDto != null) {
			cmBankdto   = (CmBankDto  )aryDto[0];
			cmBranchdto = (CmBranchDto)aryDto[1];
		}

		// コマンド毎の処理
		if (cmd.equals(CMD_CM_BANK_BRANCH_SHOW)) {
			// 表示内容初期化
			setInitItem(vo);
			// 表示
			vo.setMode(0);
			vo.setFormerKey(vo.KEY_BANK_CODE);
			vo.setIsAscending(true);
			vo.initListInfo();
		} else if (cmd.equals(CMD_CM_BANK_INSERT)) {
			// 登録
			vo.setParams(request);
			cmBankdto = insert(vo);
			// 表示内容初期化
			setInitItem(vo);
			// 検索
			searchCompanyBankBranchEdit(vo);
			vo.setFormerKey(vo.KEY_BANK_CODE);
			vo.setIsAscending(true);
			vo.initListInfo();
		} else if (cmd.equals(CMD_CM_BANK_UPDATE)) {
			// 更新
			vo.setParams(request);
			cmBankdto = update(vo, cmBankdto);
			// 表示内容初期化
			setInitItem(vo);
			// 検索
			searchCompanyBankBranchEdit(vo);
			vo.setFormerKey(vo.KEY_BANK_CODE);
			vo.setIsAscending(true);
			vo.initListInfo();
		} else if (cmd.equals(CMD_CM_BRANCH_INSERT)) {
			// 登録
			vo.setParams2(request);
			cmBranchdto = insert2(vo);
			// 表示内容初期化
			setInitItem(vo);
			// 検索
			searchCompanyBankBranchEdit(vo);
			vo.setFormerKey(vo.KEY_BANK_CODE);
			vo.setIsAscending(true);
			vo.initListInfo();
		} else if (cmd.equals(CMD_CM_BRANCH_UPDATE)) {
			// 更新
			vo.setParams2(request);
			cmBranchdto = update(vo, cmBranchdto);
			// 表示内容初期化
			setInitItem(vo);
			// 検索
			searchCompanyBankBranchEdit(vo);
			vo.setFormerKey(vo.KEY_BANK_CODE);
			vo.setIsAscending(true);
			vo.initListInfo();
		} else if (cmd.equals(CMD_CM_BANK_BRANCH_SELECT)) {
			// 表示(情報を検索)
			// DBコネクションの取得及びDTOの準備
			getConnection();
			// 銀行
			cmBankdao = new CmBankDao();
			cmBankdao.initDao(cfg, cmd, aspUser, user, conn);
			// 銀行データの取得
			cmBankdto = cmBankdao.findForKey(key1);
			// chkExistにDTOの値を入れる
			chkExist(cmBankdto);
			// VOに銀行情報をセット
			vo.setFields(cmBankdto);
			// 支店Daoの初期化
			cmBranchdao = new CmBranchDao();
			cmBranchdao.initDao(cfg, cmd, aspUser, user, conn);
			// 支店データ取得
			cmBranchdto = cmBranchdao.findForKey(key1, key2);
			// chkExistにDTOの値を入れる
			if (cmBranchdto != null) {
				chkExist(cmBranchdto);
				// VOに支店情報をセット
				vo.setFields2(cmBranchdto);
				// セッションにDTOをセット
				aryDto = new BaseDto[2];
				aryDto[0] = cmBankdto;
				aryDto[1] = cmBranchdto;
				session.setAttribute(MospConst.ATT_DTO, aryDto);
				vo.setMode(1);
			} else {
				vo.setTxtBranchCode("");
				vo.setTxtBranchName("");
				vo.setTxtBranchKana("");
				// セッションにDTOをセット
				aryDto = new BaseDto[2];
				aryDto[0] = cmBankdto;
				aryDto[1] = null;
				session.setAttribute(MospConst.ATT_DTO, aryDto);
				vo.setMode(2);
			}
		} else if (cmd.equals(CMD_CM_BANK_BRANCH_RE_SEARCH)) {
			// 再検索
			vo.setParams(request);
			vo.setParams2(request);
			session.removeAttribute(MospConst.ATT_DTO);
			vo.setTxtBankCode("");
			vo.setTxtBankName("");
			vo.setTxtBankKana("");
			vo.setTxtBranchCode("");
			vo.setTxtBranchName("");
			vo.setTxtBranchKana("");
			vo.setMode(0);
			//検索
			searchCompanyBankBranchEdit(vo);
			vo.setFormerKey(vo.KEY_BANK_CODE);
			vo.setIsAscending(true);
			vo.initListInfo();
		} else if (cmd.equals(CMD_CM_BANK_SEARCH)) {
			// 検索
			vo.setParamsSearch(request);
			searchEmployeeList2(vo);
			vo.setFormerKey(vo.KEY_BANK_CODE);
			vo.setIsAscending(true);
			vo.initListInfo();
		} else{
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/**
	 * 項目初期化
	 * @param vo
	 */
	private void setInitItem(CompanyBankBranchEditVo vo) {
		vo.setTxtBankCode("");
		vo.setTxtBankName("");
		vo.setTxtBankKana("");
		vo.setTxtBranchCode("");
		vo.setTxtBranchName("");
		vo.setTxtBranchKana("");
		
		vo.setTxtSearchBankCode  ("");
		vo.setTxtSearchBankKana  ("");
		vo.setTxtSearchBranchCode("");
		vo.setTxtSearchBranchKana("");
		
	}
	
	/**
	 * 銀行・支店マスタ一覧を取得する。<br>
	 * <ol>
	 * <li>銀行・支店マスタの全件取得。<br>
	 * <li>取得した銀行・支店マスタレコードのリストをVoにセットする。<br>
	 * </ol>
	 * @param vo CompanyBankBranchEditVoインスタンス
	 * @throws Exception
	 */
	private void searchCompanyBankBranchEdit(CompanyBankBranchEditVo vo) throws Exception {
		// DBコネクションの取得
		getConnection();
		// Daoの準備
		CmBankDao cmBankDao = new CmBankDao();
		CmBranchDao cmBranchDao = new CmBranchDao();
		// Dao初期化
		cmBankDao.initDao(cfg, cmd, aspUser, user, conn);
		cmBranchDao.initDao(cfg, cmd, aspUser, user, conn);
		List<CmBranchDto> list2 = cmBranchDao.findForEmployeeList();
		// 銀行名リスト設定
		List<CmBankDto> list = cmBankDao.findForEmployeeList();
		vo.setFields2(list2);
		vo.setFields(list);
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @throws Exception
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	public CmBankDto insert(CompanyBankBranchEditVo vo) throws Exception {
		// VOのモード設定		
		vo.setMode(0);
		// パラメータの妥当性確認
		vo.validate();
		// コネクションの取得及びDAOの準備
		getConnection();
		CmBankDao cmBankdao = new CmBankDao();
		cmBankdao.initDao(cfg, cmd, aspUser, user, conn);
		// 存在チェック
		chkDuplicate(cmBankdao.findForKey(vo.getTxtBankCode()),vo);
		// DTO準備
		CmBankDto dto = new CmBankDto();
		vo.setDtoFields(dto);
		// データ挿入
		cmBankdao.insert(dto);
		// DTO再取得
		dto = cmBankdao.findForKey(dto.getBankCode());
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return dto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	public CmBankDto update(CompanyBankBranchEditVo vo, CmBankDto dto) throws Exception {
		// VOのモード設定
		vo.setMode(1);
		// パラメータの妥当性確認
		vo.validate();
		// コネクションの取得及びDAOの準備
		getConnection();
		CmBankDao dao = new CmBankDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(vo.getTxtBankCode()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		dao.update(dto, true);
		// DTOの再取得
		CmBankDto retDto = dao.findForKey(dto.getBankCode());
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		vo.setMode(0);
		return retDto;
	}
	
	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @throws Exception
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	public CmBranchDto insert2(CompanyBankBranchEditVo vo) throws Exception {
		// VOのモード設定		
		vo.setMode(0);
		// パラメータの妥当性確認
		vo.validate2();
		// コネクションの取得及びDAOの準備
		getConnection();
		CmBankDao cmBankDao = new CmBankDao();
		CmBranchDto dto = new CmBranchDto();
		CmBranchDao dao = new CmBranchDao();
		cmBankDao.initDao(cfg, cmd, aspUser, user, conn);
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 銀行マスタに存在しない銀行コードの場合は支店を登録させない
		CmBankDto retDto = cmBankDao.findForKey(vo.getTxtBankCode());
		String bank;
		if (retDto == null) {
			bank = "";
		} else {
			bank = retDto.getBankCode();
		}
		String chk  = vo.getTxtBankCode();
		// 存在チェック
		chkDuplicate(dao.findForKey(vo.getTxtBankCode(),vo.getTxtBranchCode()),vo);
		if (chk.length() != bank.length()) {
			vo.setMessage("銀行が未登録の場合、支店登録は出来ません。");
		} else if (chk.length() == bank.length()) {
			// DTO準備
			vo.setDtoFields(dto);
			// データ挿入
			dao.insert(dto);
			// DTO再取得
			dto = dao.findForKey(dto.getBankCode(),dto.getBranchCode());
			// コミット
			commit();
			// メッセージ設定
			vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		}
		return dto;
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	public CmBranchDto update(CompanyBankBranchEditVo vo, CmBranchDto dto) throws Exception {
		// VOのモード設定
		vo.setMode(1);
		// パラメータの妥当性確認
		vo.validate2();
		// コネクションの取得及びDAOの準備
		getConnection();
		CmBranchDao dao = new CmBranchDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(vo.getTxtBankCode(),vo.getTxtBranchCode()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		dao.update(dto, true);
		// DTOの再取得
		CmBranchDto retDto = dao.findForKey(dto.getBankCode(),dto.getBranchCode());
		// コミット
		commit();
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		vo.setMode(0);
		return retDto;
	}

	/**
	 * 支店リスト検索
	 * @param vo AdjustmentCalcVoインスタンス
	 * @throws Exception
	 */
	private void searchEmployeeList2(CompanyBankBranchEditVo vo) throws Exception {
		// DBコネクションの取得
		getConnection();
		// 検索
		CmBankDao cmBankDao = new CmBankDao();
		CmBranchDao cmBranchDao = new CmBranchDao();
		cmBankDao.initDao(cfg, cmd, aspUser, user, conn);
		cmBranchDao.initDao(cfg, cmd, aspUser, user, conn);
		List<CmBranchDto> list = cmBranchDao.findForCondition(
				  vo.getEscTxtSearchBankCode  (), vo.getEscTxtSearchBankKana  ()
				, vo.getEscTxtSearchBranchCode(), vo.getEscTxtSearchBranchKana()
			);
		// フィールドに設定
		vo.setFields2(list);
		// 銀行名設定
		List<CmBankDto> list2 = cmBankDao.findForCondition(
				vo.getEscTxtSearchBankCode  (), vo.getEscTxtSearchBankKana  ()
				, vo.getEscTxtSearchBranchCode(), vo.getEscTxtSearchBranchKana()
		);
		vo.setFields(list2);
	
		// 対象が無かった場合のメッセージ設定
		if (vo.getEscAryBankCode().length == 0 || vo.getEscAryBranchCode().length == 0) {
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_NO_DATA, ""));
			return;
		}
	}
	
}

